Index: typo3/sysext/cms/tslib/class.tslib_content.php
===================================================================
--- typo3/sysext/cms/tslib/class.tslib_content.php	(revision 9624)
+++ typo3/sysext/cms/tslib/class.tslib_content.php	(revision )
@@ -815,9 +815,9 @@
 			'CLEARGIF' => 'ClearGif',
 			'COBJ_ARRAY' => 'ContentObjectArray',
 			'COA' => 'ContentObjectArray',
-			'COA_INT' => 'ContentObjectArray_Internal',
+			'COA_INT' => 'ContentObjectArrayInternal',
 			'USER' => 'User',
-			'USER_INT' => 'User_Internal',
+			'USER_INT' => 'UserInternal',
 			'FILE' => 'File',
 			'IMAGE' => 'Image',
 			'IMG_RESOURCE' => 'ImageResource',
@@ -835,7 +835,7 @@
 			'FORM' => 'Form',
 			'SEARCHRESULT' => 'SearchResult',
 			'PHP_SCRIPT' => 'PhpScript',
-			'PHP_SCRIPT_INT' => 'PhpScript_Internal',
+			'PHP_SCRIPT_INT' => 'PhpScriptInternal',
 			'TEMPLATE' => 'Template',
 			'FLUIDTEMPLATE' => 'FluidTemplate',
 			'MULTIMEDIA' => 'Multimedia',
Index: typo3/sysext/cms/ext_autoload.php
===================================================================
--- typo3/sysext/cms/ext_autoload.php	(revision 9473)
+++ typo3/sysext/cms/ext_autoload.php	(revision )
@@ -46,7 +46,7 @@
 	'tslib_content_abstract' => PATH_tslib . 'content/class.tslib_content_abstract.php',
 	'tslib_content_case' => PATH_tslib . 'content/class.tslib_content_case.php',
 	'tslib_content_cleargif' => PATH_tslib . 'content/class.tslib_content_cleargif.php',
-	'tslib_content_contentobjectarray_internal' => PATH_tslib . 'content/class.tslib_content_contentobjectarray_internal.php',
+	'tslib_content_contentobjectarrayinternal' => PATH_tslib . 'content/class.tslib_content_contentobjectarrayinternal.php',
 	'tslib_content_contentobjectarray' => PATH_tslib . 'content/class.tslib_content_contentobjectarray.php',
 	'tslib_content_columns' => PATH_tslib . 'content/class.tslib_content_columns.php',
 	'tslib_content_content' => PATH_tslib . 'content/class.tslib_content_content.php',
@@ -64,7 +64,7 @@
 	'tslib_content_media' => PATH_tslib . 'content/class.tslib_content_media.php',
 	'tslib_content_multimedia' => PATH_tslib . 'content/class.tslib_content_multimedia.php',
 	'tslib_content_offsettable' => PATH_tslib . 'content/class.tslib_content_offsettable.php',
-	'tslib_content_phpscript_internal' => PATH_tslib . 'content/class.tslib_content_phpscript_internal.php',
+	'tslib_content_phpscriptinternal' => PATH_tslib . 'content/class.tslib_content_phpscriptinternal.php',
 	'tslib_content_phpscript' => PATH_tslib . 'content/class.tslib_content_phpscript.php',
 	'tslib_content_quicktimeobject' => PATH_tslib . 'content/class.tslib_content_quicktimeobject.php',
 	'tslib_content_records' => PATH_tslib . 'content/class.tslib_content_records.php',
@@ -74,7 +74,7 @@
 	'tslib_content_shockwaveflashobject' => PATH_tslib . 'content/class.tslib_content_shockwaveflashobject.php',
 	'tslib_content_template' => PATH_tslib . 'content/class.tslib_content_template.php',
 	'tslib_content_text' => PATH_tslib . 'content/class.tslib_content_text.php',
-	'tslib_content_user_internal' => PATH_tslib . 'content/class.tslib_content_user_internal.php',
+	'tslib_content_userinternal' => PATH_tslib . 'content/class.tslib_content_userinternal.php',
 	'tslib_content_user' => PATH_tslib . 'content/class.tslib_content_user.php',
 	'tslib_content_editpanel' => PATH_tslib . 'content/class.tslib_content_editpanel.php',
 );
Index: typo3/sysext/cms/tslib/content/class.tslib_content_phpscript_internal.php
===================================================================
--- typo3/sysext/cms/tslib/content/class.tslib_content_phpscript_internal.php	(revision 9259)
+++ typo3/sysext/cms/tslib/content/class.tslib_content_phpscriptinternal.php	(revision )
@@ -33,7 +33,7 @@
  * @author Xavier Perseguers <typo3@perseguers.ch>
  * @author Steffen Kamper <steffen@typo3.org>
  */
-class tslib_content_PhpScript_Internal extends tslib_content_Abstract {
+class tslib_content_PhpScriptInternal extends tslib_content_Abstract {
 
 	/**
 	 * Rendering the cObject, PHP_SCRIPT_INT and PHP_SCRIPT_EXT
@@ -62,8 +62,8 @@
 }
 
 
-if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['tslib/content/class.tslib_content_phpscript_internal.php']) {
-	include_once ($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['tslib/content/class.tslib_content_phpscript_internal.php']);
+if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['tslib/content/class.tslib_content_phpscriptinternal.php']) {
+	include_once ($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['tslib/content/class.tslib_content_phpscriptinternal.php']);
 }
 
 ?>
\ No newline at end of file
Index: typo3/sysext/cms/tslib/content/class.tslib_content_contentobjectarray_internal.php
===================================================================
--- typo3/sysext/cms/tslib/content/class.tslib_content_contentobjectarray_internal.php	(revision 9268)
+++ typo3/sysext/cms/tslib/content/class.tslib_content_contentobjectarrayinternal.php	(revision )
@@ -33,7 +33,7 @@
  * @author Xavier Perseguers <typo3@perseguers.ch>
  * @author Steffen Kamper <steffen@typo3.org>
  */
-class tslib_content_ContentObjectArray_Internal extends tslib_content_Abstract {
+class tslib_content_ContentObjectArrayInternal extends tslib_content_Abstract {
 
 	/**
 	 * Rendering the cObject, COA_INT
@@ -64,8 +64,8 @@
 }
 
 
-if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['tslib/content/class.tslib_content_contentobjectarray_internal.php']) {
-	include_once ($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['tslib/content/class.tslib_content_contentobjectarray_internal.php']);
+if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['tslib/content/class.tslib_content_contentobjectarrayinternal.php']) {
+	include_once ($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['tslib/content/class.tslib_content_contentobjectarrayinternal.php']);
 }
 
 ?>
\ No newline at end of file
Index: typo3/sysext/cms/tslib/content/class.tslib_content_user_internal.php
===================================================================
--- typo3/sysext/cms/tslib/content/class.tslib_content_user_internal.php	(revision 9214)
+++ typo3/sysext/cms/tslib/content/class.tslib_content_userinternal.php	(revision )
@@ -33,7 +33,7 @@
  * @author Xavier Perseguers <typo3@perseguers.ch>
  * @author Steffen Kamper <steffen@typo3.org>
  */
-class tslib_content_User_Internal extends tslib_content_Abstract {
+class tslib_content_UserInternal extends tslib_content_Abstract {
 
 	/**
 	 * Rendering the cObject, USER_INT
@@ -58,8 +58,8 @@
 }
 
 
-if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['tslib/content/class.tslib_content_user_internal.php']) {
-	include_once ($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['tslib/content/class.tslib_content_user_internal.php']);
+if (defined('TYPO3_MODE') && $TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['tslib/content/class.tslib_content_userinternal.php']) {
+	include_once ($TYPO3_CONF_VARS[TYPO3_MODE]['XCLASS']['tslib/content/class.tslib_content_userinternal.php']);
 }
 
 ?>
\ No newline at end of file