Index: typo3/sysext/rtehtmlarea/ext_tables.php
===================================================================
--- typo3/sysext/rtehtmlarea/ext_tables.php	(révision 9881)
+++ typo3/sysext/rtehtmlarea/ext_tables.php	(copie de travail)
@@ -22,10 +22,12 @@
 		),
 	);
 	t3lib_extMgm::allowTableOnStandardPages('tx_rtehtmlarea_acronym');
+	t3lib_extMgm::addLLrefForTCAdescr('tx_rtehtmlarea_acronym','EXT:' . $_EXTKEY . '/locallang_csh_abbreviation.xml');
 
 		// Add contextual help files
 	$htmlAreaRteContextHelpFiles = array(
 		'General' => 'EXT:' . $_EXTKEY . '/locallang_csh.xml',
+		'Acronym' => 'EXT:' . $_EXTKEY . '/extensions/Acronym/locallang_csh.xml',
 		'EditElement' => 'EXT:' . $_EXTKEY . '/extensions/EditElement/locallang_csh.xml',
 		'Language' => 'EXT:' . $_EXTKEY . '/extensions/Language/locallang_csh.xml',
 		'PlainText' => 'EXT:' . $_EXTKEY . '/extensions/PlainText/locallang_csh.xml',
Index: typo3/sysext/rtehtmlarea/extensions/Acronym/locallang_csh.xml
===================================================================
--- typo3/sysext/rtehtmlarea/extensions/Acronym/locallang_csh.xml	(révision 0)
+++ typo3/sysext/rtehtmlarea/extensions/Acronym/locallang_csh.xml	(révision 0)
@@ -0,0 +1,47 @@
+<?xml version="1.0" encoding="utf-8" standalone="yes" ?>
+<T3locallang>
+	<meta type="array">
+		<description>CSH for Aconym Extension of htmlArea RTE</description>
+		<type>CSH</type>
+		<csh_table>xEXT_rtehtmlarea_Acronym</csh_table>
+	</meta>
+	<data type="array">
+		<languageKey index="default" type="array">
+			<label index=".alttitle">htmlArea RTE &gt; Abbreviation</label>
+			<label index=".description">The "Abbreviation" dialogue allows to associate an abbreviation to a term.</label>
+			<label index=".details">Clicking the "Insert abbreviation" icon in the RTE tool bar opens a dialogue that allows to insert an abbreviation or to edit one that already exists in the content.
+Any existing abbreviation is underlined with a broken line and the cursor changes to a question mark when the mouse goes over it.
+The dialogue allows to associate an abbreviation to a term. The abbreviation may be selected among abbreviations that have been pre-defined in the database or may be entered directly in the dialogue.</label>
+			<label index=".image">EXT:rtehtmlarea/extensions/Acronym/skin/images/acronym.gif</label>
+			<label index=".image_descr">"Insert abbreviation" icon in the editor tool bar.</label>
+			<label index=".seeAlso">xEXT_rtehtmlarea_Acronym:preDefinedAbbreviation,
+xEXT_rtehtmlarea_Acronym:unabridgedTerm,
+xEXT_rtehtmlarea_Acronym:abridgedTerm,
+xEXT_rtehtmlarea_Acronym:language,
+xEXT_rtehtmlarea_Acronym:termToAbridge,
+xEXT_rtehtmlarea_Acronym:useThisTerm
+tx_rtehtmlarea_acronym
+</label>
+			<label index="preDefinedAbbreviation.alttitle">Pre-defined abbreviations</label>
+			<label index="preDefinedAbbreviation.description">This section lets you select abbreviations already defined in the database.</label>
+			<label index="preDefinedAbbreviation.seeAlso">tx_rtehtmlarea_acronym</label>
+			<label index="preDefinedAcronym.alttitle">Pre-defined acronyms</label>
+			<label index="preDefinedAcronym.description">This section lets you select acronyms already defined in the database.</label>
+			<label index="preDefinedAcronym.seeAlso">tx_rtehtmlarea_acronym</label>
+			<label index="unabridgedTerm.alttitle">Unabbreviated term</label>
+			<label index="unabridgedTerm.description">Select the unabbreviated form of the term.</label>
+			<label index="unabridgedTerm.details">The selected term will be set as the title attribute of the abbreviation (or acronym) element.</label>
+			<label index="abridgedTerm.alttitle">Abbreviation</label>
+			<label index="abridgedTerm.description">Select the short form of the term.</label>
+			<label index="language.alttitle">Language</label>
+			<label index="language.description">Select the language for which the abbreviation is defined.</label>
+			<label index="language.details">The selected language will be set as the language attribute of the abbreviation (or acronym) element.
+If a pre-defined abbreviation (or acronym) is selected, the language for which it is defined, if any, is initially selected.</label>
+			<label index="termToAbridge.alttitle">Term to abbreviate</label>
+			<label index="termToAbridge.description">This section lets you enter a term for which the current selection will be the short form.</label>
+			<label index="useThisTerm.alttitle">Use this term</label>
+			<label index="useThisTerm.description">Enter the term that you want to associate as the unabbreviated form of the current selection.</label>
+			<label index="useThisTerm.details">The entered term will be set as the title attribute of the abbreviation (or acronym) element.</label>
+		</languageKey>
+	</data>
+</T3locallang>
Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/Acronym/acronym.js
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/Acronym/acronym.js	(révision 9881)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/Acronym/acronym.js	(copie de travail)
@@ -42,7 +42,7 @@
 		 * Registering plugin "About" information
 		 */
 		var pluginInformation = {
-			version		: '2.2',
+			version		: '2.3',
 			developer	: 'Stanislas Rolland',
 			developerUrl	: 'http://www.sjbr.ca/',
 			copyrightOwner	: 'Stanislas Rolland',
@@ -77,8 +77,7 @@
 			typeAhead: true,
 			triggerAction: 'all',
 			forceSelection: true,
-			mode: 'local',
-			helpIcon: true
+			mode: 'local'
 		}
 	},
 	/*
@@ -110,7 +109,7 @@
 		};
 			// Open the dialogue window
 		this.openDialogue(
-			'Insert/Modify Acronym',
+			this.getButton(buttonId).tooltip.title,
 			buttonId,
 			this.getWindowDimensions({ width: 580}, buttonId),
 			this.buildTabItemsConfig(abbr),
@@ -133,7 +132,7 @@
 	 */
 	openDialogue: function (title, buttonId, dimensions, tabItems, buttonsConfig, activeTab) {
 		this.dialog = new Ext.Window({
-			title: this.localize(title),
+			title: this.getHelpTip('', title),
 			cls: 'htmlarea-window',
 				// As of ExtJS 3.1, JS error with IE when the window is resizable
 			resizable: !Ext.isIE,
@@ -241,9 +240,8 @@
 			xtype: 'combo',
 			displayField: 'term',
 			valueField: 'term',
-			fieldLabel: this.localize('Unabridged_term'),
+			fieldLabel: this.getHelpTip('unabridgedTerm', 'Unabridged_term'),
 			itemId: 'termSelector',
-			helpTitle: this.localize('Select_a_term'),
 			tpl: '<tpl for="."><div ext:qtip="{abbr}" style="text-align:left;font-size:11px;" class="x-combo-list-item">{term}</div></tpl>',
 			store: new Ext.data.JsonStore({
 				autoDestroy:  true,
@@ -275,9 +273,8 @@
 			displayField: 'abbr',
 			valueField: 'abbr',
 			tpl: '<tpl for="."><div ext:qtip="{language}" style="text-align:left;font-size:11px;" class="x-combo-list-item">{abbr}</div></tpl>',
-			fieldLabel: this.localize('Abridged_term'),
+			fieldLabel: this.getHelpTip('abridgedTerm', 'Abridged_term'),
 			itemId: 'abbrSelector',
-			helpTitle: this.localize('Select_an_' + type),
 			store: new Ext.data.JsonStore({
 				autoDestroy:  true,
 				autoLoad: true,
@@ -331,10 +328,8 @@
 			});
 			itemsConfig.push(Ext.apply({
 				xtype: 'combo',
-				fieldLabel: this.localize('Language'),
+				fieldLabel: this.getHelpTip('language', 'Language'),
 				itemId: 'language',
-				helpTitle: this.localize('Select_a_language'),
-				helpText: this.localize('Language_' + type + '_helpText'),
 				valueField: 'value',
 				displayField: 'text',
 				tpl: '<tpl for="."><div ext:qtip="{value}" style="text-align:left;font-size:11px;" class="x-combo-list-item">{text}</div></tpl>',
@@ -355,7 +350,7 @@
 		}
 		return {
 			xtype: 'fieldset',
-			title: this.localize('Defined_' + type),
+			title: this.getHelpTip('preDefined' + ((type == 'abbr') ? 'Abbreviation' : 'Acronym'), 'Defined_' + type),
 			items: itemsConfig,
 			listeners: {
 				render: {
@@ -437,7 +432,8 @@
 	 * Handler when a term is selected
 	 */
 	onTermSelect: function (combo, record, index) {
-		var tab = combo.findParentByType('container');
+		var fieldset = combo.findParentByType('fieldset');
+		var tab = fieldset.findParentByType('container');
 		var term = record.get('term');
 		var abbr = record.get('abbr');
 		var language = record.get('language');
@@ -460,7 +456,8 @@
 	 * Handler when an abbreviation or acronym is selected
 	 */
 	onAbbrSelect: function (combo, record, index) {
-		var tab = combo.findParentByType('container');
+		var fieldset = combo.findParentByType('fieldset');
+		var tab = fieldset.findParentByType('container');
 		var term = record.get('term');
 		var language = record.get('language');
 			// Update the term selector
@@ -488,20 +485,16 @@
 	buildUseTermFieldsetConfig: function (element, type) {
 		var itemsConfig = [];
 		itemsConfig.push({
-			fieldLabel: this.localize('Use_this_term'),
+			fieldLabel: this.getHelpTip('useThisTerm', 'Use_this_term'),
 			labelSeparator: '',
 			itemId: 'useTerm',
 			value: element ? element.title : '',
-			width: 300,
-			helpTitle: this.localize('Use_this_term_explain')
+			width: 300
 		});
 		return {
 			xtype: 'fieldset',
-			title: this.localize('Term_to_abridge'),
+			title: this.getHelpTip('termToAbridge', 'Term_to_abridge'),
 			defaultType: 'textfield',
-			defaults: {
-				helpIcon: true
-			},
 			items: itemsConfig
 		};
 	},
@@ -562,6 +555,10 @@
 				button.setDisabled(((el.nodeName.toLowerCase() == 'acronym' && this.pageTSConfiguration.noAcronym) || (el.nodeName.toLowerCase() == 'abbr' && this.pageTSConfiguration.noAbbr)));
 				button.setInactive(!(el.nodeName.toLowerCase() == 'acronym' && !this.pageTSConfiguration.noAcronym) && !(el.nodeName.toLowerCase() == 'abbr' && !this.pageTSConfiguration.noAbbr));
 			}
+			button.setTooltip({
+				title: this.localize((button.disabled || button.inactive) ? 'Insert abbreviation' : 'Edit abbreviation')
+			});
+			button.contextMenuTitle = '';
 			if (this.dialog) {
 				this.dialog.focus();
 			}
Index: typo3/sysext/rtehtmlarea/htmlarea/plugins/Acronym/locallang.xml
===================================================================
--- typo3/sysext/rtehtmlarea/htmlarea/plugins/Acronym/locallang.xml	(révision 9881)
+++ typo3/sysext/rtehtmlarea/htmlarea/plugins/Acronym/locallang.xml	(copie de travail)
@@ -7,15 +7,16 @@
 	</meta>
 	<data type="array">
 		<languageKey index="default" type="array">
-			<label index="Insert/Modify Acronym">Insert/Modify Acronym or Abbreviation</label>
-			<label index="Acronym-contextMenuTitle">Insert/modify abbreviation</label>
-			<label index="Term_to_abridge">Term to abridge</label>
+			<label index="Insert/Modify Acronym">Insert/edit abbreviation</label>
+			<label index="Insert abbreviation">Insert abbreviation</label>
+			<label index="Edit abbreviation">Edit abbreviation</label>
+			<label index="Term_to_abridge">Term to abbreviate</label>
 			<label index="Defined_acronym">Pre-defined acronyms</label>
 			<label index="Defined_abbr">Pre-defined abbreviations</label>
 			<label index="Term">Term</label>
-			<label index="Unabridged_term">Unabridged Term</label>
+			<label index="Unabridged_term">Term</label>
 			<label index="Select_a_term">Select a term</label>
-			<label index="Abridged_term">Abridged Term</label>
+			<label index="Abridged_term">Short form</label>
 			<label index="Acronym">Acronym</label>
 			<label index="Abbreviation">Abbreviation</label>
 			<label index="Select_an_acronym">Select an acronym</label>
Index: typo3/sysext/rtehtmlarea/locallang_csh_abbreviation.xml
===================================================================
--- typo3/sysext/rtehtmlarea/locallang_csh_abbreviation.xml	(révision 0)
+++ typo3/sysext/rtehtmlarea/locallang_csh_abbreviation.xml	(révision 0)
@@ -0,0 +1,28 @@
+<?xml version="1.0" encoding="utf-8" standalone="yes" ?>
+<T3locallang>
+	<meta type="array">
+		<description>Context Sensitive Help for table</description>
+		<type>CSH</type>
+		<csh_table>tx_rtehtmlarea_acronym</csh_table>
+	</meta>
+	<data type="array">
+		<languageKey index="default" type="array">
+			<label index=".description">An 'Abbreviation' associates a short form to a given term. The abbreviation may be defined for a specific language.</label>
+			<label index=".details">Defined abbreviations are used in the htmlArea RTE Abbreviation dialogue.
+A defined abbreviation may further be configured so as to be made available only when editing content in a given language.</label>
+			<label index=".seeAlso">xEXT_rtehtmlarea_Acronym</label>
+			<label index="term.description">Enter the term to be abbreviated.</label>
+			<label index="acronym.description">Enter the short form of the term.</label>
+			<label index="hidden.description">Check this option if you wish to disable the availability of this entry to non-admin users.</label>
+			<label index="type.description">Select the type of abbreviation.</label>
+			<label index="type.details">A defined abbreviation may be of two types: abbreviation or acronym. These correspond to HTML elements abbr and acronym. Note however that acronym is deprecated in recent versions of HTML.</label>
+			<label index="starttime.description">Enter a time at which you want the abbreviation to start being available to non-admin users.
+If no time is specified, the abbreviation becomes immediately available to the users of the RTE, if not hidden.</label>
+			<label index="endtime.description">Enter a date and time at which you want the abbreviation to stop being available to non-admin users.
+If no time is specified, the abbreviation is indefinitely available to the users of the RTE, unless it is hidden.</label>
+			<label index="sys_language_uid.description">Select the language of content elements in which the abbreviation may be used.</label>
+			<label index="static_lang_isocode.description">Select the language for which the abbreviation is defined.</label>
+			<label index="static_lang_isocode.details">The selected language will be used as the value of the language attribute of the HTML element inserted in the content element by the RTE.</label>
+		</languageKey>
+	</data>
+</T3locallang>
\ No newline at end of file
Index: typo3/sysext/rtehtmlarea/locallang_db.xml
===================================================================
--- typo3/sysext/rtehtmlarea/locallang_db.xml	(révision 9881)
+++ typo3/sysext/rtehtmlarea/locallang_db.xml	(copie de travail)
@@ -6,13 +6,13 @@
 	</meta>
 	<data type="array">
 		<languageKey index="default" type="array">
-			<label index="tx_rtehtmlarea_acronym">Acronym</label>
+			<label index="tx_rtehtmlarea_acronym">Abbreviation</label>
 			<label index="tx_rtehtmlarea_acronym.type">Type</label>
 			<label index="tx_rtehtmlarea_acronym.type.I.0">Acronym</label>
 			<label index="tx_rtehtmlarea_acronym.type.I.1">Abbreviation</label>
 			<label index="tx_rtehtmlarea_acronym.term">Term</label>
-			<label index="tx_rtehtmlarea_acronym.acronym">Abridged form</label>
-			<label index="tx_rtehtmlarea_acronym.static_lang_isocode">Language of term</label>
+			<label index="tx_rtehtmlarea_acronym.acronym">Abbreviation</label>
+			<label index="tx_rtehtmlarea_acronym.static_lang_isocode">Language of the abbreviation</label>
 		</languageKey>
 	</data>
 	<orig_hash type="array">
Index: typo3/sysext/rtehtmlarea/tca.php
===================================================================
--- typo3/sysext/rtehtmlarea/tca.php	(révision 9881)
+++ typo3/sysext/rtehtmlarea/tca.php	(copie de travail)
@@ -63,8 +63,8 @@
 			'config' => Array (
 				'type' => 'radio',
 				'items' => Array (
+					Array('LLL:EXT:rtehtmlarea/locallang_db.xml:tx_rtehtmlarea_acronym.type.I.1', '2'),
 					Array('LLL:EXT:rtehtmlarea/locallang_db.xml:tx_rtehtmlarea_acronym.type.I.0', '1'),
-					Array('LLL:EXT:rtehtmlarea/locallang_db.xml:tx_rtehtmlarea_acronym.type.I.1', '2'),
 				),
 				'default' => '2',
 			)