Index: typo3/sysext/t3skin/extjs/xtheme-t3skin.css
===================================================================
--- typo3/sysext/t3skin/extjs/xtheme-t3skin.css	(Revision 10092)
+++ typo3/sysext/t3skin/extjs/xtheme-t3skin.css	(Arbeitskopie)
@@ -1332,32 +1332,50 @@
 	height:15px;
 }
 
+.x-tree-node-el {
+	line-height: 18px;
+	height: 18px;
+	margin-right: 0;
+}
+
+.x-tree-lines .x-tree-elbow-end,
+.x-tree-lines .x-tree-elbow-end-minus,
+.x-tree-lines .x-tree-elbow-end-plus,
+.x-tree-lines .x-tree-elbow-line,
+.x-tree-lines .x-tree-elbow,
+.x-tree-lines .x-tree-elbow-plus,
+.x-tree-lines .x-tree-elbow-minus {
+	background-repeat: repeat-y;
+	background-position: 0 1px;
+	height: 20px;
+}
+
 .x-tree-lines .x-tree-elbow{
-	background-image:url(images/tree/elbow.gif);
+	background-image: url('../icons/gfx/ol/join.gif');
 }
 
-.x-tree-lines .x-tree-elbow-plus{
-	background-image:url(images/tree/elbow-plus.gif);
+.x-tree-lines .x-tree-elbow-plus {
+	background-image: url('../icons/gfx/ol/plus.gif');
 }
 
-.x-tree-lines .x-tree-elbow-minus{
-	background-image:url(images/tree/elbow-minus.gif);
+.x-tree-lines .x-tree-elbow-minus {
+	background-image: url('../icons/gfx/ol/minus.gif');
 }
 
-.x-tree-lines .x-tree-elbow-end{
-	background-image:url(images/tree/elbow-end.gif);
+.x-tree-lines .x-tree-elbow-end-minus {
+	background: url('../icons/gfx/ol/minusbottom.gif') left top no-repeat;
 }
 
-.x-tree-lines .x-tree-elbow-end-plus{
-	background-image:url(images/tree/elbow-end-plus.gif);
+.x-tree-lines .x-tree-elbow-end {
+	background: url('../icons/gfx/ol/joinbottom.gif') left top no-repeat;
 }
 
-.x-tree-lines .x-tree-elbow-end-minus{
-	background-image:url(images/tree/elbow-end-minus.gif);
+.x-tree-lines .x-tree-elbow-end-plus{
+	background: url('../icons/gfx/ol/plusbottom.gif') left top no-repeat;
 }
 
 .x-tree-lines .x-tree-elbow-line{
-	background-image:url(images/tree/elbow-line.gif);
+	background-image: url('../icons/gfx/ol/line.gif');
 }
 
 .x-tree-no-lines .x-tree-elbow-plus{
@@ -1397,12 +1415,15 @@
 	font: normal 10px verdana, arial, tahoma, helvetica, sans-serif;
 }
 
-.x-tree-node a, .x-dd-drag-ghost a{
-	color:#000;
+.x-tree-node a, .x-dd-drag-ghost a {
+	color: #000;
+	vertical-align: -1px;
+	font-size: 11px;
+	display: inline-block;
 }
 
-.x-tree-node a span, .x-dd-drag-ghost a span{
-	color:#000;
+.x-tree-node a span, .x-dd-drag-ghost a span {
+	color: #000;
 }
 
 .x-tree-node .x-tree-node-disabled a span{
Index: typo3/sysext/t3skin/stylesheets/structure/element_pagetree.css
===================================================================
--- typo3/sysext/t3skin/stylesheets/structure/element_pagetree.css	(Revision 0)
+++ typo3/sysext/t3skin/stylesheets/structure/element_pagetree.css	(Revision 0)
@@ -0,0 +1,195 @@
+/* - - - - - - - - - - - - - - - - - - - - -
+Pagetree
+
+$Id: $
+- - - - - - - - - - - - - - - - - - - - - */
+
+#typo3-pagetree,
+#typo3-pagetree .x-panel-bwrap,
+#typo3-pagetree .x-panel-body {
+	height: 100%;
+}
+
+#typo3-pagetree .x-panel-tbar {
+	padding: 0;
+	margin: 0;
+}
+
+.x-tree-node .x-tree-node-el {
+	margin-right: 0;
+}
+
+.x-tree-node-readableRootline {
+	padding: 10px 0 3px 10px;
+}
+
+.x-tree-lines .typo3-pagetree-node-notExpandable .x-tree-ec-icon {
+	visibility: hidden;
+}
+
+.x-tree-lines .typo3-pagetree-node-notExpandable ul .x-tree-ec-icon {
+	visibility: visible;
+}
+
+#typo3-pagetree span.t3-icon {
+	margin-bottom: 2px;
+}
+
+#typo3-pagetree .x-toolbar,
+.typo3-pagetree-topPanel-item .x-toolbar {
+	padding-bottom: 0;
+}
+
+#typo3-pagetree ul.x-tree-root-ct {
+	padding-left: 5px;
+	padding-top: 15px;
+}
+
+/**
+ *
+ * section drag and drop
+ *
+ */
+.typo3-pagetree-tree-copy {
+	margin-top: 5px;
+}
+
+.x-dd-drag-ghost-pagetree-text {
+	display: inline-block;
+	vertical-align: middle;
+}
+
+.x-dd-drag-ghost-pagetree,
+.x-dd-drag-ghost {
+	padding-bottom: 5px;
+}
+
+.x-dd-drop-icon {
+	padding-top: 6px;
+}
+
+.x-dd-drag-ghost span {
+	margin: 0 1px 0 3px;
+}
+
+.x-dd-drag-ghost-pagetree span {
+	margin: 3px 3px 0 3px;
+}
+
+/**
+ *
+ * @section Top Panel
+ *
+ */
+#typo3-pagetree-topPanel .x-toolbar-left {
+	height: 20px;
+}
+
+.typo3-pagetree-topPanel-button {
+	margin: 0 5px 0 0;
+	padding: 1px 2px;
+	height: 18px;
+}
+
+.typo3-pagetree-topPanel-button button {
+	height: 16px;
+	width: 16px;
+}
+
+.typo3-pagetree-topPanel-item {
+	padding: 5px 3px 0 3px;
+	height: 22px;
+}
+
+#typo3-pagetree-topPanel-filterWrap {
+	padding-top: 3px;
+	height: 24px;
+}
+
+#typo3-pagetree-topPanel-filter {
+	height: 16px;
+	width: 98% !important;
+	padding: 1px 0 1px 2px;
+}
+
+#typo3-pagetree-topPanel-filterWrap .t3-icon-input-clear {
+	right: 2%;
+}
+
+#typo3-pagetree .typo3-pagetree-topPanel-button {
+	margin-right: 1px;
+	margin-top: -2px;
+	padding: 2px 3px;
+}
+
+#typo3-pagetree-topPanel-defaultPanel {
+	padding-left: 6px;
+}
+
+#typo3-pagetree-topPanel-filterWrap .x-form-field-trigger-wrap {
+	width: 100% !important;
+	margin: 0 20px 0 0;
+}
+
+.typo3-pagetree-topPanel-item .x-form-trigger {
+	margin: 4px 0 0;
+	display: none;
+}
+
+.typo3-pagetree-topPanel-item .x-form-field-trigger-wrap:hover .x-form-trigger {
+	display: block;
+}
+
+#typo3-pagetree .typo3-pagetree-filteringTree-highlight {
+	padding: 0;
+}
+
+/**
+ *
+ * @section Indicator Bar
+ *
+ */
+.typo3-pagetree-indicatorBar-item p {
+	padding: 5px 10px;
+}
+
+#typo3-pagetree-indicatorBar-filter p,
+#typo3-pagetree-indicatorBar-temporaryMountPoint p {
+	padding: 10px 35px;
+}
+
+.typo3-pagetree-indicatorBar-item .typo3-pagetree-indicatorBar-item-leftIcon {
+	left: 10px;
+	top: 9px;
+	position: absolute;
+}
+
+.typo3-pagetree-indicatorBar-item .typo3-pagetree-indicatorBar-item-rightIcon {
+	right: 10px;
+	top: 5px;
+	position: absolute;
+}
+
+#typo3-pagetree-indicatorBar-indicatorTitle span {
+	margin-right: 10px;
+}
+
+/**
+ *
+ * @section Deletion Drop Zone
+ *
+ */
+#typo3-pagetree-deletionDropZone p {
+	padding: 5px;
+}
+
+#typo3-pagetree-deletionDropZone-text {
+	padding: 0 0 0 5px;
+	display: inline;
+}
+
+.typo3-pagetree-deletionDropZone-restore {
+	display: inline-block;
+	padding: 0px 6px;
+	margin-left: 24px;
+}
\ No newline at end of file
Index: typo3/sysext/t3skin/stylesheets/ie6/pagetree.css
===================================================================
--- typo3/sysext/t3skin/stylesheets/ie6/pagetree.css	(Revision 0)
+++ typo3/sysext/t3skin/stylesheets/ie6/pagetree.css	(Revision 0)
@@ -0,0 +1,40 @@
+/* - - - - - - - - - - - - - - - - - - - - -
+Pagetree
+
+$Id: $
+- - - - - - - - - - - - - - - - - - - - - */
+#typo3-pagetree .typo3-pagetree-topPanel-button {
+	margin: 0;
+	padding: 0 2px;
+}
+
+#typo3-pagetree .typo3-pagetree-topPanel-button button {
+	margin: 0;
+	padding: 0;
+	width: 16px;
+	height: 16px;
+	overflow: hidden;
+}
+
+#typo3-pagetree #typo3-pagetree-indicatorBar {
+	padding: 0;
+	line-height: normal;
+}
+
+#typo3-pagetree #typo3-pagetree-topPanel {
+	height: 53px;
+}
+
+#typo3-pagetree .x-tree-node .x-tree-node-el {
+	border-top: 1px solid #EBEBEB;
+	border-bottom: 1px solid #EBEBEB;
+	border-left: 1px solid #EBEBEB;
+}
+
+#typo3-pagetree-topPanel-filterWrap .x-form-field-trigger-wrap {
+	display: inline-block;
+}
+
+.x-dd-drag-proxy {
+	width: 1em;
+}
\ No newline at end of file
Index: typo3/sysext/t3skin/stylesheets/visual/element_pagetree.css
===================================================================
--- typo3/sysext/t3skin/stylesheets/visual/element_pagetree.css	(Revision 0)
+++ typo3/sysext/t3skin/stylesheets/visual/element_pagetree.css	(Revision 0)
@@ -0,0 +1,340 @@
+/* - - - - - - - - - - - - - - - - - - - - -
+Pagetree
+
+$Id: $
+- - - - - - - - - - - - - - - - - - - - - */
+#typo3-pagetree-treeContainer,
+#typo3-pagetree-topPanelItems {
+	background-color: #EBEBEB;
+}
+
+#typo3-pagetree .x-tree .x-panel-body {
+	background: none;
+}
+
+#typo3-pagetree .x-tree-node .x-tree-node-el {
+	border-top: 1px solid transparent;
+	border-bottom: 1px solid transparent;
+	border-left: 1px solid transparent;
+}
+
+#typo3-pagetree .x-tree-node .x-tree-node-over,
+#typo3-pagetree .x-tree-node .x-tree-selected {
+	background-color: #F8F8F8;
+	border-bottom: 1px solid #D7D7D7;
+	border-top: 1px solid #D7D7D7;
+	border-left: 1px solid #D7D7D7;
+}
+
+#typo3-pagetree .x-panel-tbar {
+	background-color: #585858;
+	border: none;
+}
+
+/**
+ *
+ * @section drag and drop
+ *
+ */
+.typo3-pagetree-tree-copy {
+	color: #666;
+}
+
+.x-dd-drag-ghost {
+	background-color: inherit;
+	border: none;
+	-moz-box-shadow: 0px 1px 3px rgba(0, 0, 0, 0.3);
+	-ms-box-shadow: 0px 1px 3px rgba(0, 0, 0, 0.3);
+	-webkit-box-shadow: 0px 1px 3px rgba(0, 0, 0, 0.3);
+	box-shadow: 0px 1px 3px rgba(0, 0, 0, 0.3);
+}
+
+.x-dd-drop-nodrop {
+	background-color: #f6d3cf;
+	border: 1px solid #d66c68;
+}
+
+.typo3-pagetree-deletionDropZone-proxyOver,
+.x-tree-drop-ok-append,
+.x-tree-drop-ok-between,
+.x-tree-drop-ok-below,
+.x-tree-drop-ok-above {
+	background-color: #dce8f4;
+	border: 1px solid #9eb2c5;
+}
+
+.x-dd-drop-nodrop .x-dd-drop-icon {
+	background-image: url(../../images/icons/apps/pagetree-drag-place-denied.png);
+}
+
+.x-tree-drop-ok-append.typo3-pagetree-copy .x-dd-drop-icon {
+	background-image: url(../../images/icons/apps/pagetree-drag-new-inside.png);
+}
+
+.x-tree-drop-ok-below.typo3-pagetree-copy .x-dd-drop-icon {
+	background-image: url(../../images/icons/apps/pagetree-drag-copy-below.png);
+}
+
+.x-tree-drop-ok-above.typo3-pagetree-copy .x-dd-drop-icon {
+	background-image: url(../../images/icons/apps/pagetree-drag-copy-above.png);
+}
+
+.x-tree-drop-ok-between.typo3-pagetree-copy .x-dd-drop-icon {
+	background-image: url(../../images/icons/apps/pagetree-drag-new-between.png);
+}
+
+.x-tree-drop-ok-append .x-dd-drop-icon {
+	background-image: url(../../images/icons/apps/pagetree-drag-move-into.png);
+}
+
+.x-tree-drop-ok-between .x-dd-drop-icon {
+	background-image: url(../../images/icons/apps/pagetree-drag-move-between.png);
+}
+
+.x-tree-drop-ok-below .x-dd-drop-icon {
+	background-image: url(../../images/icons/apps/pagetree-drag-move-below.png);
+}
+
+.x-tree-drop-ok-above .x-dd-drop-icon {
+	background-image: url(../../images/icons/apps/pagetree-drag-move-above.png);
+}
+
+#typo3-pagetree .x-tree-node .x-tree-drag-insert-below,
+.x-tree-node div.x-tree-drag-insert-below,
+.x-tree-dd-underline .x-tree-node div.x-tree-drag-insert-below a {
+	border-bottom: 1px solid #9eb2c5;
+}
+
+#typo3-pagetree .x-tree-node .x-tree-drag-insert-above,
+.x-tree-node .x-tree-drag-insert-above,
+.x-tree-dd-underline .x-tree-node div.x-tree-drag-insert-above a {
+	border-top: 1px solid #9eb2c5;
+}
+
+.x-tree-node .x-tree-drag-append {
+	background: #d7e4f1;
+}
+
+.x-tree-node .x-tree-drag-append a span {
+	background-color: inherit;
+	border: none;
+}
+
+/**
+ *
+ * @section Top Panel
+ *
+ */
+#typo3-pagetree .x-toolbar {
+	background: none;
+	border: none;
+}
+
+.typo3-pagetree-topPanel-button {
+	background: none;
+	border: none;
+}
+
+#typo3-pagetree-topPanel .x-btn-pressed {
+	background-image: url('../../icons/gfx/toolbar_item_active_bg.png');
+}
+
+#typo3-pagetree-topPanel .x-btn-click {
+	border: none;
+	top: 0;
+	left: 0;
+}
+
+#typo3-pagetree-topPanel button:focus {
+	outline: none;
+}
+
+#typo3-pagetree-topPanel button::-moz-focus-inner {
+	border: 0;
+}
+
+.typo3-pagetree-topPanel-button button {
+	border: none;
+}
+
+#typo3-pagetree .typo3-pagetree-topPanel-item {
+	background-color: #dadada;
+	line-height: normal;
+}
+
+#typo3-pagetree-topPanel-filter {
+	border: 1px solid #AEAEAE;
+	-moz-box-shadow: inset 0 1px 4px #AEAEAE;
+	-ms-box-shadow: inset 0 1px 4px #AEAEAE;
+	-webkit-box-shadow: inset 0 1px 4px #AEAEAE;
+	box-shadow: inset 0 2px 1px #AEAEAE;
+}
+
+.typo3-pagetree-topPanel-filter-defaultText {
+	color: gray;
+}
+
+#typo3-pagetree-topPanelItems,
+.typo3-pagetree-indicatorBar-item,
+#typo3-pagetree-topPanel .typo3-pagetree-topPanel-item,
+#typo3-pagetree-treeContainer {
+	-moz-box-shadow: inset -2px 0 0px #C4C4C4;
+	-ms-box-shadow: inset -2px 0 0px #C4C4C4;
+	-webkit-box-shadow: inset -2px 0 0px #C4C4C4;
+	box-shadow: inset -2px 0 0px #C4C4C4;
+}
+
+#typo3-pagetree .typo3-pagetree-topPanel-button {
+	border: none;
+	border-radius: 0;
+}
+
+#typo3-pagetree .typo3-pagetree-topPanel-button button {
+	vertical-align: middle;
+}
+
+#typo3-pagetree-topPanel-defaultPanel {
+	color: #A2AAB8;
+	line-height: 18px;
+}
+
+#typo3-pagetree-topPanel-item-newNode .x-btn-over {
+	background: inherit;
+}
+
+#typo3-pagetree-topPanel-item-newNode button {
+	cursor: move;
+}
+
+#typo3-pagetree-topPanel-button-refresh,
+#typo3-pagetree-topPanel-button-refresh.x-btn-over {
+	background: inherit;
+}
+
+/**
+ *
+ * @section Tree Highlighting
+ *
+ */
+
+#typo3-pagetree .ver-element,
+#typo3-pagetree .ver-versions,
+#typo3-pagetree .ver-page {
+	background-color: #f7c898;
+}
+
+#typo3-pagetree .x-tree-node-over.ver-element,
+#typo3-pagetree .x-tree-node-over.ver-versions,
+#typo3-pagetree .x-tree-node-over.ver-page,
+#typo3-pagetree .x-tree-selected.ver-element,
+#typo3-pagetree .x-tree-selected.ver-versions,
+#typo3-pagetree .x-tree-selected.ver-page {
+	background-color: #fee4c9;
+}
+
+.x-tree-node-readableRootline {
+	font-style: italic;
+}
+
+#typo3-pagetree .typo3-pagetree-filteringTree-highlight {
+	background-color: #F48E0C;
+	color: #FFF;
+}
+
+/**
+ *
+ * @section Indicator Bar
+ *
+ */
+
+#typo3-pagetree-indicatorBar-temporaryMountPoint p {
+	line-height: 13px;
+}
+
+#typo3-pagetree-indicatorBar-temporaryMountPoint,
+#typo3-pagetree-indicatorBar-filter {
+	background-color: #EAF7FF;
+	border-bottom: 1px solid #C5DBE6;
+	color: #4C73A1;
+}
+
+.typo3-pagetree-indicatorBar-item .typo3-pagetree-indicatorBar-item-rightIcon {
+	cursor: pointer;
+}
+
+#typo3-pagetree-indicatorBar-indicatorTitle {
+	background-color: #ffec97;
+	font-weight: bold;
+}
+
+/**
+ *
+ * @section Deletion Drop Zone
+ *
+ */
+
+#typo3-pagetree-deletionDropZone {
+	color: #FFF;
+	background-color: #585858;
+	-moz-box-shadow: inset 0 2px 5px #414141;
+	-ms-box-shadow: inset 0 2px 5px #414141;
+	-webkit-box-shadow: inset 0 2px 5px #414141;
+	box-shadow: inset 0 2px 5px #414141;
+}
+
+#typo3-pagetree-deletionDropZone-text {
+	font-size: .9em;
+}
+
+.typo3-pagetree-deletionDropZone-restore {
+	background-color: #d5d5d5;
+	background-image: url('../../images/backgrounds/button.png');
+	background-repeat: repeat-x;
+	background-image: -moz-linear-gradient(center top, #f6f6f6 10%, #d5d5d5 90%);
+	background-image: -webkit-gradient(linear, 0% 0%, 0% 100%, color-stop(0.1, #f6f6f6), color-stop(0.9, #d5d5d5));
+	background-image: linear-gradient(center top, #f6f6f6 10%, #d5d5d5 90%);
+	border: 1px solid #7c7c7c;
+	-moz-border-radius: 1px;
+	-webkit-border-radius: 1px;
+	border-radius: 1px;
+	color: #434343;
+	cursor: pointer;
+}
+
+.typo3-pagetree-deletionDropZone-restore:hover {
+	background-color: #c8c8c8;
+	background-image: url('../../images/backgrounds/button-hover.png');
+	background-image: linear-gradient(center top, #f6f6f6 10%, #c8c8c8 90%);
+	background-image: -moz-linear-gradient(center top, #f6f6f6 10%, #bdbcbc 90%);
+	background-image: -webkit-gradient(linear, 0% 0%, 0% 100%, color-stop(0.1, #f6f6f6), color-stop(0.9, #c8c8c8));
+	background-position: bottom;
+	background-repeat: repeat-x;
+	border: 1px solid #737f91;
+	color: #1e1e1e;
+}
+
+.typo3-pagetree-deletionDropZone-restoreText {
+	background: transparent url("../../extjs/images/grid/loading.gif") no-repeat 0 3px;
+	padding: 4px 4px 4px 18px;
+	display: inline-block;
+}
+
+#typo3-pagetree .x-panel-tbar,
+#typo3-pagetree-deletionDropZone .x-panel-body {
+	-moz-box-shadow: inset -2px 0 1px #414141;
+	-ms-box-shadow: inset -2px 0 1px #414141;
+	-webkit-box-shadow: inset -2px 0 1px #414141;
+	box-shadow: inset -2px 0 1px #414141;
+}
+
+.typo3-pagetree-deletionDropZone-proxyOver .x-dd-drop-icon {
+	background-image: url(../../images/icons/actions/edit-delete.png);
+}
+
+#typo3-pagetree .typo3-pagetree-deletionDropZone-activateProxyOver {
+	background-color: #644D2D;
+}
+
+#typo3-pagetree-deletionDropZone-text {
+	cursor: default;
+}}
\ No newline at end of file